
/**
 * Write a description of class AbstractCar here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public abstract class AbstractCar implements Car
{
    private double emptyFuelConsumption;
    private String type;
    private int tankCapacity;
    private double fuel;
    
    
    /**
     * Constructor for objects of class AbstractCar
     * @param emptyFuelConsumption consumption of empty car
     * @param type type of the car
     * @param tankCapacity capacity of car's fuel tank
     * @param fuel amount of fuel in the car
     */
    public AbstractCar(double emptyFuelConsumption, String type, 
                       int tankCapacity, double fuel) {
        this.emptyFuelConsumption = emptyFuelConsumption;
        this.type = type;
        this.tankCapacity = tankCapacity;
        this.fuel = fuel;
    }
    
    /**
     * Returns empty consumption of the car
     * @return empty consumption of the car
     */
    public double getEmptyConsumption()
    {
        return emptyFuelConsumption;
    }
    
        
    /**
     * Returns the type of the car.
     * @return type of the car.
     */
    
    public String getType()
    {
        return type;
    }
    
    public void refuel(int fuelAmount)
    {
       if (fuel + fuelAmount <= tankCapacity)
         fuel += fuelAmount;
         else fuel = tankCapacity;
    }
    
    public void run(int distance){
        if(getConsumption() * distance / 100 <= this.fuel){
            this.fuel -= getConsumption() * distance / 100;
        }
    }
    
    public String toString()
    {
        return type + "(" + tankCapacity + "/" + fuel + ")";
    }
}
