
/**
 * Write a description of interface Car here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */

public interface Car
{
    /**
     * Runs the distance suplied as a parameter
     * @param distance distance to be ran
     */
    public void run(int distance);
    
    /**
     * Refuels the car
     * @param fuelLoad the amount of fuel to be refueled
     */
    public void refuel(int fuelAmount);
    
    /**
     * Loads the amount of a cargo/persons
     * @param cargo amount of a cargo/persons
     * @return amount of really loaded cargo/persons
     */
    public int load(int cargo);
    
    /**
     * Unloads the amount of cargo/persons, if available, else fully unloads the car.
     * @param cargo amount of a cargo/persons
     * @return amount of unloaded cargo/persons
     */
    
    public int unload(int cargo);
    
    /**
     * The total fuel consumption of the car
     * @return the total fuel consumption of the car
     */
    public double getConsumption();
}
