
/**
 * Write a description of class PersonalCar here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PersonalCar extends AbstractCar
{
    // instance variables - replace the example below with your own
    private int persons; //persons on board
    private int maxPersons; //maximum of  allowed persons

    /**
     * Constructor for objects of class PersonalCar
     * @param type car type
     * @param maxPersons maximum number of allowed persons
     * @param persons persons to be initiali loaded. When persons  &gt; maxPersons only 
     *                maxPersons will be loaded.
     * @param fuel amount of fuel
     * @param emptyFuelConsumption consumption of empty car
     * @param tankCapacity capacity of the car's tank
     */
    public PersonalCar(String type, int maxPersons, int persons,
                       double fuel, double emptyFuelConsumption, int tankCapacity)
    {
        super(emptyFuelConsumption, type, tankCapacity, fuel);
        this.maxPersons = maxPersons;
        this.persons = persons;
    }
            
    
    /**
     * Returns String representation of the particular object.
     * @return String representation of the object in the form:
     *                  "<type> (maxPersons): <persons> persons \n"
     * 
     */
    
    /**
     * Returns fuelConsumption of the car.
     * @return fuel consumption according the formula 
     *               emptyFuelConsumption + 0.05 * persons
     */
    public double getConsumption()
    {
        return getEmptyConsumption() + 0.01 * persons;
    }
    public int unload(int persons) 
    {
      int unloaded;
      if (this.persons >= persons) {
          unloaded = persons; 
          this.persons -= persons;
        }
          else {
              unloaded = this.persons;
              this.persons = 0;
            }
            return unloaded;
    }
    
    public int load(int persons){
        int loaded;
        if (this.persons + persons <= maxPersons){
            loaded = persons;
            this.persons += persons;
        }
        else {
            loaded = maxPersons - this.persons;
            this.persons = maxPersons;
        }
        return loaded;
    }
    
    public String toString()
    {
        return super.toString() + "Capacity: " + maxPersons +"; " + persons;
    }
    
}
